import java.awt.*;
import java.awt.image.*;
import java.applet.Applet;
import java.awt.MediaTracker;
import java.util.*;

public class AnimateContinuous extends Animate implements Runnable {
    protected boolean tx_threadSuspended;
    protected boolean img_threadSuspended;

    public boolean mouseDown(Event evt, int x, int y) {
        int i;

        // Handle the image maps first
        for(i=0;i<num_maps;i++) {
            if(x > map_x1[i] && x < map_x2[i] &&
               y > map_y1[i] && y < map_y2[i]) {
                if(map_url[i] != null) {
                    if(testmode) {
                        getAppletContext().showStatus("Loading URL: " +
                                    map_url[i].toString());
                    } else
                        getAppletContext().showDocument(map_url[i]);
                    return true;
                }
            }
        }    

        // Handle the text next (Text takes precedence over images)
        if(tx_index != -1) {
            if(x > tx_x_coord[tx_index] && 
               x < tx_x_coord[tx_index] + tx_width[tx_index] &&
               y > tx_y_coord[tx_index] && 
               y < tx_y_coord[tx_index] + tx_height[tx_index]) {
                if(tx_url != null) {
                    getAppletContext().showDocument(tx_url);
                    return true;
                }
                if(tx_threadSuspended)
                    tx_animator.resume();
                else
                    tx_animator.suspend();
                tx_threadSuspended = !tx_threadSuspended;
            }    
        }

        // Handle the image last
        if(img_index != -1) {
            if(x > img_x_coord[img_index] &&
               x < img_x_coord[img_index] + img_width[img_index] &&
               y > img_y_coord[img_index] &&
               y < img_y_coord[img_index] + img_height[img_index]) {
                if(img_url != null) {
                    getAppletContext().showDocument(img_url);
                    return true;
                }
                if(img_threadSuspended)
                    img_animator.resume();
                else
                    img_animator.suspend();
                img_threadSuspended = !img_threadSuspended;
            }    
        }
        return true;
    }
}
