import java.awt.*;
import java.awt.image.*;
import java.applet.Applet;
import java.awt.MediaTracker;

public class AnimateTwoWay extends Animate implements Runnable {
    boolean tx_goingup = true;
    boolean img_goingup = true;

    // getNextTxIndex() is called right before repaint
    public int getNextTxIndex(int current, int max, int min) {
        if(tx_goingup == true)
            current++;
        else
            current--;
    
        if(current >= max) {
            current -= 2;
            tx_goingup = false;
        }
        if(current < min) {
            current = min+1;
            tx_goingup = true;
        }
        return current;
    }

    // getNextImgIndex() is called right before repaint
    public int getNextImgIndex(int current, int max, int min) {
        if(img_goingup == true)
            current++;
        else
            current--;
    
        if(current >= max) {
            current -= 2;
            img_goingup = false;
        }
        if(current < min) {
            current = min+1;
            img_goingup = true;
        }
        return current;
    }
    
    // tx_sleep() is called right after repaint
    public void tx_sleep(int s_runs, int s_images,
                            int current, int max, int min) {
        try {
            if(current == min || current == max-1)
                Thread.sleep(s_runs);
            else
                Thread.sleep(s_images);
        } catch (InterruptedException e) {}
    }

    // img_sleep() is called right after repaint
    public void img_sleep(int s_runs, int s_images,
                            int current, int max, int min) {
        tx_sleep(s_runs, s_images, current, max, min);
    }
}
