import java.awt.Graphics;
import java.awt.Font;
import java.awt.FontMetrics;
import java.awt.Color;
import java.applet.Applet;
import java.awt.Event;
import java.awt.Image;

public class Coalesce extends SAnimate {

    int         Index = 0;              // Index 
    int         xval[];                 // X values for char position
    int         yval[];                 // Y values for char position
    boolean     coalescing = true;      // Direction
    int         steps;                  // Number of steps in movement

    public void init() {
        super.init();

        steps = GetParm.toInt(this, "Steps", 50);

        // tx is set up in StringAnimation
        xval =  new int [tx.length()];
        yval =  new int [tx.length()];

        // Calculate original random positions
        calc_new_random();
    }

    public void paint(Graphics g) {

        super.paint(g);
            
        if(Index == 0) {
            offGC.setColor(getBackground());
            offGC.fillRect(0, 0, size().width, size().height);
        }
            
        offGC.setColor(getBackground());
        offGC.fillRect(0, 0, size().width, size().height);
        tilebackground(offGC);
        offGC.setColor(getForeground());
        for(int i=0;i<tx.length();i++) {
            offGC.drawChars(separated, i, 1,
                calcval(xval[i], xoffset+xlocation[i], Index, steps),
                calcval(yval[i], yoffset, Index, steps));
        }
        g.drawImage(offScreen, 0, 0, this);

        // If the characters are not supposed to be moving then
        // we don't want an expose event to increment or decrement
        // the position of the characters
        if(StringThread != null) {
            if(coalescing) {
                Index++;
                if(Index > steps) {
                    endofstring = true;
                    Index = steps;
                    calc_new_random();
                    coalescing = false;
                }
            } else {
                Index--;
                if(Index < 0) {
                    endofstring = true;
                    Index = 0;
                    coalescing = true;
                }
            }
        }

    }

    public void run() {
        thread_running = true;
        endofstring = false;
        while (StringThread != null) {
            try {Thread.sleep(chardelay);} catch (InterruptedException e){}
            if(endofstring == true) {
                thread_running = false;
                StringThread = null;
                endofstring = false;
            } else
                repaint();
        }
    }

    public int calcval(int from, int to, int index, int range) {
        int value;
        if(from == to) {
            value = from;
        } else if(from > to) {
            value = from - ((from - to) * index / range);
        } else {
            value = from + ((to - from) * index / range);
        }
        return value;
    }

    public synchronized boolean mouseEnter(Event evt, int x, int y) {
        if(StringThread == null) {
            StringThread = new Thread(this);
            StringThread.start();
        } else {
            coalescing = true;
        }
        return true;
    }

    public synchronized boolean mouseExit(Event evt, int x, int y) {
        if(StringThread == null) {
            StringThread = new Thread(this);
            StringThread.start();
        } else {
            coalescing = false;
        }
        return true;
    }
    
    public boolean keyDown(Event evt, int key) {
        int x = evt.x;
        int y = evt.y;

        if(key == 'f') {
            chardelay *= .9;
            if(chardelay < 2)
                chardelay = 2;
            getAppletContext().showStatus("Setting image delay to: " +
                        chardelay);
        } else if(key == 's') {
            if(chardelay < 10)
                chardelay++;
            else
                chardelay *= 1.1;
            getAppletContext().showStatus("Setting image delay to: " +
                        chardelay);
        }
        return true;
    }
        

    public void start() {
        Index = 0;
    }

    public void calc_new_random() {
        for(int i=0;i<tx.length();i++) {
            xval[i] = (int)((Math.random()*1000.0) % size().width);
            yval[i] = (int)((Math.random()*1000.0) % size().height);
        }
    }
}
