import java.awt.*;
import java.applet.Applet;
import java.net.*;
import java.io.*;

abstract class SAnimate extends Applet implements Runnable {
    protected char              separated[];
    protected char              separateda[][];
    protected Thread            StringThread = null;
    protected int               xlocation[];
    protected int               xlocationa[][];
    protected int               xwidth[];
    protected int               xwidtha[][];
    protected boolean           threadSuspended = false;
    protected int               chardelay;
    protected int               rundelay;
    protected boolean           endofstring = false;
    protected int               total_width;
    protected int               total_widtha[];
    protected boolean           thread_running;

    // Parameters that apply to the entire applet
    protected Color       app_bg_color;         // Applet background color
    protected Image       offScreen;           
    protected Graphics    offGC;           
    protected int         applet_width;
    protected int         applet_height;
    protected int         app_height;
    protected int         app_width;
    protected String      bgimage_file;
    protected Image       bgimage;
    protected boolean     tile;
    protected int         bgimage_height;
    protected int         bgimage_width;
    protected Image       tiled_bgimage;
    protected Graphics    bg_g;
    protected ImgGetr     ig;

    // Parameters specific to Text
    protected String      tx;                // Text
    protected String      txa[];             // Text array
    protected int         xoffset;           // Text X offset
    protected int         yoffset;           // Text Y offset
    protected Color       textcolor;         // Text color
    protected boolean     horizcenter;       // Text horizontally centered
    protected boolean     vertcenter;        // Text vertically centered
    protected Font        font;              // Text font
    protected FontMetrics fontmetrics;       // Text font metrics
    protected boolean     underline;         // Text underline
    protected int         width;             // Text width
    protected int         widtha[];          // Text width array
    protected int         height;            // Text height
    protected int         ascent;            // Text ascent
    protected int         descent;           // Text descent
    protected int         txcount;           // number of texts

    public void init() {
        int i, j;
        // Applet parameters
        app_bg_color    = GetParm.toColor(this,   "AppBGColor", null);

        // Text parameters
        txcount      = GetParm.toInt(this,    "TextCount", 0);
        tx           = GetParm.toString(this, "Text", "");
        xoffset      = GetParm.toInt(this,     "XOffset", 0);
        yoffset      = GetParm.toInt(this,     "YOffset", -1);
        textcolor    = GetParm.toColor(this,   "TextColor", null);
        horizcenter  = GetParm.toBoolean(this, "HorizCenter", false);
        vertcenter   = GetParm.toBoolean(this, "VertCenter",  false);
        font         = GetParm.toFont(this,    "Font",
                                               "Style",
                                               "PointSize");
        if(txcount > 0)
            txa = new String[txcount];
        for(i=0;i < txcount;i++)
            txa[i] = GetParm.toString(this, "Text"+(i+1), "");

        chardelay      = GetParm.toInt(this, "DelayBetweenChars", 20);
        rundelay       = GetParm.toInt(this, "DelayBetweenRuns", 3000);

        // ======== BG Image ===========
        tile           = GetParm.toBoolean(this, "AppTile",     false);
        bgimage_file   = GetParm.toString(this,  "AppBGImage",  null);

        if(bgimage_file != null) {
            ig = new ImgGetr(this);
            bgimage = ig.process(getDocumentBase(), bgimage_file, false);
            ig.prepareImage(bgimage, this);
            bgimage_width = ig.getWidth(bgimage, this);
            bgimage_height = ig.getHeight(bgimage, this);
        }


        setFont(font);
        fontmetrics = getFontMetrics(font);

        width  = fontmetrics.stringWidth(tx);
        height = fontmetrics.getHeight();
        ascent = fontmetrics.getMaxAscent();
        descent = fontmetrics.getDescent();
        if(txcount > 0)
            widtha = new int[txcount];
        for(i=0;i < txcount;i++)
            widtha[i]  = fontmetrics.stringWidth(txa[i]);
            

        // Set the background and foreground colors, if specified
        if(app_bg_color != null)
            setBackground(app_bg_color);
        else
            app_bg_color = getBackground();
        if(textcolor != null)
            setForeground(textcolor);
        else
            textcolor = getForeground();

        // Allocate space for array of chars, location, and width 
        separated =  new char [tx.length()];
        xlocation =  new int  [tx.length()];
        xwidth    =  new int  [tx.length()];
        if(txcount > 0) {
            separateda = new char[txcount][];
            xlocationa = new int [txcount][];
            xwidtha    = new int [txcount][];
        }
        for(i=0;i < txcount;i++) {
            separateda[i] =  new char [txa[i].length()];
            xlocationa[i] =  new int  [txa[i].length()];
            xwidtha[i]    =  new int  [txa[i].length()];
            txa[i].getChars(0, txa[i].length(), separateda[i], 0);
        }

        // Put each character from the string into the separated array
        tx.getChars(0,tx.length(),separated,0);


        // Calculate the x locations for each character based on width
        if(txcount > 0)
            total_widtha = new int[txcount];
        for(i=0;i < txcount;i++)
            total_widtha[i] = 0;

        for(i=0;i<txcount;i++) {
            for(j=0;j<txa[i].length();j++) {
                xwidtha[i][j] = fontmetrics.charWidth(separateda[i][j]);
                total_widtha[i] += xwidtha[i][j];
                if(j+1<txa[i].length())
                    xlocationa[i][j+1] = total_widtha[i];
            }
        }


        total_width = 0;
        for(i=0;i<tx.length();i++) {
            xwidth[i] = fontmetrics.charWidth(separated[i]);
            total_width += xwidth[i];
            if(i+1<tx.length())
                xlocation[i+1] = total_width;
        }
        offScreen = createImage(size().width, size().height);
        offGC = offScreen.getGraphics();
        offGC.setFont(font);
    }

    //
    // Overwrite the default update method
    // This may not be necessary for this case
    // but it certainly doesn't hurt
    //
    public void update(Graphics g) {
        paint(g);
    }

    public void paint(Graphics g) {

        // If this is the first time we've been in paint
        // or the applet has changed size then create
        // an image the size of the applet into which
        // we write the background image
        if(applet_width != size().width ||
           applet_height!= size().height) {
            applet_width  = size().width;
            applet_height = size().height;
            offScreen = createImage(applet_width, applet_height);
            offGC = offScreen.getGraphics();
            offGC.setFont(font);
        }
        // We never know when the size might change so check it every time
        if(horizcenter) {
            xoffset = (size().width / 2) - (total_width / 2);
        }
        if(vertcenter) {
            yoffset = (size().height / 2) + (ascent / 3);
        } else if(yoffset == -1) {
            yoffset = height - descent;
        }
        if(tile) {
            tilebackground(offGC);
        } else {
            offGC.setColor(getBackground());
            offGC.fillRect(0, 0, applet_width, applet_height);
        }
    }

    public void start() {
        if(StringThread == null) {
            StringThread = new Thread(this);
            StringThread.start();
        }
    }

    public void stop() {
        if(StringThread != null)
            StringThread.stop();
        StringThread = null;
    }

    public boolean keyDown(Event evt, int key) {
        int x = evt.x;
        int y = evt.y;

        if(key == 'f') {
            chardelay *= .9;
            if(chardelay < 2)
                chardelay = 2;
            getAppletContext().showStatus("Setting image delay to: " +
                        chardelay);
        } else if(key == 's') {
            if(chardelay < 10)
                chardelay++;
            else
                chardelay *= 1.1;
            getAppletContext().showStatus("Setting image delay to: " +
                        chardelay);
        } else if(key == 'F') {
            rundelay *= .9;
            if(rundelay < 2)
                rundelay = 2;
            getAppletContext().showStatus("Setting run delay to: " +
                        rundelay);
        } else if(key == 'S') {
            if(rundelay < 10)
                rundelay++;
            else
                rundelay *= 1.1;
            getAppletContext().showStatus("Setting run delay to: " +
                        rundelay);
        }
        return true;
    }

    // 
    // Tile the background with the specified image
    //
    protected synchronized void tilebackground(Graphics g) {
        int i, j;

        if(bgimage == null)
            return;
        if(ig.isImagePrepared(bgimage, this) == false)
            ig.loadImageAndWait(bgimage, this);
        //
        // If the applet has changed size or this is the first time
        // tilebackground has been called then create the bg image
        //
        if(app_width != size().width || app_height != size().height) {
            app_width  = size().width;
            app_height = size().height;

            tiled_bgimage = createImage(size().width, size().height); 
            bg_g = tiled_bgimage.getGraphics();
            bg_g.setColor(app_bg_color);
            bg_g.fillRect(0, 0, size().width, size().height);
            if(tile) {
                for(i=-bgimage_height;i<app_height;i+=bgimage_height) {
                    for(j=-bgimage_width;j<app_width;j+=bgimage_width) {
                        bg_g.drawImage(bgimage, j+2, i+2, this);
                    }
                }
            } else {
                bg_g.drawImage(bgimage, 0, 0, this);
            }
        }

        if(tiled_bgimage != null) {
            g.drawImage(tiled_bgimage, 0, 0, this);
        }
    }
}
