import java.awt.Graphics;
import java.awt.Font;
import java.awt.FontMetrics;
import java.awt.Color;
import java.applet.Applet;
import java.awt.Event;

public class TrackFade extends SAnimate {

    int fade_to_red, fade_to_green, fade_to_blue;
    int red, green, blue;
    int FadeSize;
    Color FadeToColor;
    Color FadeColor[];
    int ColorIndex[];
    int index = 0;

    public void init() {
        super.init();

        FadeToColor   = GetParm.toColor(this, "FadeToColor", null);

        FadeSize = GetParm.toInt(this, "FadeSize", 10);

        // Fade To Color
        if(FadeToColor == null) {
            FadeToColor = getBackground();
        }
        red   = getForeground().getRed();
        green = getForeground().getGreen();
        blue  = getForeground().getBlue();
        fade_to_red   = FadeToColor.getRed();
        fade_to_green = FadeToColor.getGreen();
        fade_to_blue  = FadeToColor.getBlue();

        FadeColor = new Color[FadeSize];
        ColorIndex = new int[FadeSize];
        for(int i=1;i<FadeSize;i++)
            ColorIndex[i] = -1;
        ColorIndex[0] = 0;
        for(int i=FadeSize-1;i>0;i--) {
            FadeColor[i] = new Color(
                AdjColor.CalcFade(red,  fade_to_red,   i, FadeSize),
                AdjColor.CalcFade(green,fade_to_green, i, FadeSize),
                AdjColor.CalcFade(blue, fade_to_blue,  i, FadeSize));

        }
        FadeColor[FadeSize-1] = FadeToColor;
        FadeColor[0] = getForeground();
    }

    public synchronized void paint(Graphics g) {
        int i, j;

        super.paint(g);

        if(txcount <= 0)
            return;

        // Override the super's xoffset calculation
        if(horizcenter) {
            xoffset = (size().width / 2) - (total_widtha[index] / 2);
        }

        for(i=0;i<txa[index].length();i++) {
	    offGC.setColor(FadeToColor);
	    offGC.drawChars(separateda[index], i, 1,
		    xoffset+xlocationa[index][i], yoffset);
	}
        for(i=0;i<txa[index].length()+FadeSize;i++) {
            for(j=0;j<FadeSize;j++) {
                if(ColorIndex[j] == i) {
                    offGC.setColor(FadeColor[j]);
                    if(i < txa[index].length())
                        offGC.drawChars(separateda[index], i, 1,
                                xoffset+xlocationa[index][i], yoffset);
		}
            }
        }
        g.drawImage(offScreen, 0, 0, this);
        for(i=FadeSize-1;i>0;i--)
            ColorIndex[i] = ColorIndex[i-1];

        if(ColorIndex[FadeSize-1] == txa[index].length())
            endofstring = true;
        if(ColorIndex[0] == -2) {
            // do nothing
        } else if(ColorIndex[0] == txa[index].length()) {
            ColorIndex[0] = -2;
        } else 
            ColorIndex[0]++;
        
    }

    public void run() {
        int i;
        endofstring = false;
        while (StringThread != null) {
            try {Thread.sleep(chardelay);} catch (InterruptedException e){}
            if(endofstring == true) {
                index++;
                if(index == txcount) {
                    index = 0;
                }
                for(i=1;i<FadeSize;i++)
                    ColorIndex[i] = -1;
                ColorIndex[0] = 0;
                try {Thread.sleep(rundelay);} catch (InterruptedException e){}
                endofstring = false;
            } else
                repaint();
        }
    }
}
