import java.awt.Graphics;
import java.awt.Font;
import java.awt.FontMetrics;
import java.awt.Color;
import java.applet.Applet;
import java.awt.Event;

public class Tracker extends SAnimate {

    int         ColoredIndex = 0;
    boolean     redraw_last_char = false;
    Color       HighlightColor;
    int         strIndex;

    public void init() {
        super.init();
        HighlightColor = GetParm.toColor(this, "HighlightColor",
                        Color.white);
    }

    public synchronized void paint(Graphics g) {
        int i;

        super.paint(g);

        if(txcount <= 0)
            return;
        // Override the supers xoffset calculation
        if(horizcenter) {
            xoffset = (size().width / 2) - (total_widtha[strIndex] / 2);
        }

        // Each time this is called, draw all the characters in
        // the foreground color before beginning the highlight
        offGC.setColor(getForeground());
        for(i=0;i<txa[strIndex].length();i++)
            offGC.drawChars(separateda[strIndex], i, 1,
                xoffset+xlocationa[strIndex][i], yoffset);

        // If we have reached the end of the string then draw the
        // current image to the screen (nothing highlighted) and
        // increment strIndex
        if(endofstring) {
            endofstring = false;
            g.drawImage(offScreen, 0, 0, this);
            strIndex++;
            if(strIndex >= txcount)
                strIndex = 0;
            return;
        }

        // Skip spaces, it flows better
        if(Character.isSpace(separateda[strIndex][ColoredIndex]))
            ColoredIndex = (ColoredIndex == txa[strIndex].length() - 1) ? 0 :
                                        ColoredIndex+1;


        // Now draw the highlighted character
        offGC.setColor(HighlightColor);
        offGC.drawChars(separateda[strIndex], ColoredIndex, 1,
                            xoffset+xlocationa[strIndex][ColoredIndex],
                            yoffset);
        offGC.setColor(getForeground());


        g.drawImage(offScreen, 0, 0, this);
        ColoredIndex = (ColoredIndex == txa[strIndex].length() - 1)
                                ? 0 : ColoredIndex+1;
        if(ColoredIndex == 0) {
            endofstring = true;
            redraw_last_char = true;
        }
    }

    public void run() {
        endofstring = false;
        while (StringThread != null) {
            try {Thread.sleep(chardelay);} catch (InterruptedException e){}
            if(endofstring == true) {
                repaint();      // To draw last char
                try {Thread.sleep(rundelay);} catch (InterruptedException e){}
                endofstring = false;
            } else
                repaint();
        }
    }

    public void start() {
        super.start();
        ColoredIndex = 0;
    }
}
