import java.awt.Color;

public class AdjColor {
    static int CalcFade(int from, int to, int perc, int scale) {
        
        return((from > to) ?
            to + ((from - to) * (scale-perc) / scale) :
            from + ((to - from) * perc / scale));
    }

    static Color darkenit(int r, int g, int b, double factor) {
        return new Color(Math.max((int)(r * (1 - factor)), 0),
                         Math.max((int)(g * (1 - factor)), 0),
                         Math.max((int)(b * (1 - factor)), 0));
    }

    //
    // The brightenit method in awt/Color.java doesn't really do
    // it right.  If your color is black (#000000) their brighter
    // method does not make it brighter.  You put in black
    // and you get back black.  I think this algorithm makes more
    // sense.
    static Color brightenit(int r, int g, int b, double factor) {
        int r2, g2, b2;
        r2 = r + (int)((255 - r) * factor);
        g2 = g + (int)((255 - g) * factor);
        b2 = b + (int)((255 - b) * factor);
        return new Color(r2, g2, b2);
    }

    static Color darkenit(Color c, double factor) {
        int r, g, b;
        r = c.getRed();
        g = c.getGreen();
        b = c.getBlue();
        return darkenit(r, g, b, factor);
    }

    static Color brightenit(Color c, double factor) {
        int r, g, b;
        r = c.getRed();
        g = c.getGreen();
        b = c.getBlue();
        return brightenit(r, g, b, factor);
    }

    static Color Fade(Color from, Color to, double factor) {
        int from_r, from_g, from_b;
        int to_r, to_g, to_b;
        int r, g, b;

        from_r = from.getRed();
        from_g = from.getGreen();
        from_b = from.getBlue();
        to_r = to.getRed();
        to_g = to.getGreen();
        to_b = to.getBlue();
        if(from_r > to_r)
            r = to_r + (int)((from_r - to_r)*factor);
        else
            r = to_r - (int)((to_r - from_r)*factor);
        if(from_g > to_g)
            g = to_g + (int)((from_g - to_g)*factor);
        else
            g = to_g - (int)((to_g - from_g)*factor);
        if(from_b > to_b)
            b = to_b + (int)((from_b - to_b)*factor);
        else
            b = to_b - (int)((to_b - from_b)*factor);
        
        return new Color(r, g, b);
    }
}
