import java.applet.*;
import java.awt.*;
import java.awt.image.*;
import java.net.*;
import java.util.*;

public class Filter {
    int new_w = -1;
    int new_h = -1;

    public int[] invoke(Applet applet, String tx, String f_str, 
                        int[] p1, int w, int h,
                        boolean maketransparent, Color bgcolor,
                        boolean underline) {
	return invoke(applet, tx, f_str, p1, w, h, maketransparent, 
			bgcolor, underline, applet.getFont());
    }

    public int[] invoke(Applet applet, String tx, String f_str, 
                        int[] p1, int w, int h,
                        boolean maketransparent, Color bgcolor,
                        boolean underline, Font font) {

        StringTokenizer st, st2;
        int             num_elements;
        int             num_params[];
        String          filter_strings[];
        String          param_strings[][];
        int             i, j;
        Class           cl;
        ImgFilt         filterclass;

        new_w = w;
        new_h = h;
        if(f_str != null) {
            st = new StringTokenizer(f_str, "|");
            num_elements = st.countTokens();
            filter_strings = new String[num_elements];
            param_strings  = new String[num_elements][];
            num_params     = new int[num_elements];

            for(i=0;i<num_elements;i++) {
                String tmp_str, tmp_str2;
                tmp_str = st.nextToken();
                tmp_str2 = new String(tmp_str);
                st2 = new StringTokenizer(tmp_str2, " ");
                num_params[i] = st2.countTokens();
                if(num_params[i] == 1) {
                    filter_strings[i] = tmp_str;
                    param_strings[i] = null;
                } else {
		    param_strings[i] = new String[num_params[i]-1];
                    filter_strings[i] = st2.nextToken();
                    for(j=0;j<num_params[i]-1;j++) {
                        param_strings[i][j] = st2.nextToken();
                    }
                }
            }
            for(i=0;i<num_elements;i++) {
                try {
                    cl = Class.forName("f" + filter_strings[i]);
                    filterclass = (ImgFilt)cl.newInstance();
                    for(j=0;j<num_params[i]-1;j++)
                        filterclass.setparameter(param_strings[i][j], j);
                    filterclass.setBackground(bgcolor);
                    filterclass.setForeground(applet.getForeground());
                    filterclass.setFont(font);
                    filterclass.setApplet(applet);
                    filterclass.setText(tx);
                    filterclass.setUnderline(underline);
                    // When we call setTransparent(true) this
                    // means that the background color will be
                    // used as the transparent color
                    filterclass.setTransparent(maketransparent);
                    p1 = filterclass.filter(p1, new_w, new_h);
                    new_w = filterclass.getWidth();
                    new_h = filterclass.getHeight();
                } catch (ClassNotFoundException e) {
                    System.err.println("Can't find class " + filter_strings[i]);
                } catch (InstantiationException e) {
                    System.err.println("Couldn't instantiate class " + filter_strings[i]);
                } catch (IllegalAccessException e) {
                    System.err.println("Couldn't access class " + filter_strings[i]);
                }
            }
        }
        return p1;
    }

    public int getWidth() {
        return new_w;
    }

    public int getHeight() {
        return new_h;
    }
}
