import java.applet.Applet;
import java.awt.Color;
import java.net.URL;
import java.awt.Font;
import java.net.MalformedURLException;

public class GetParm {

    public static int toInt(Applet applet, String par, int defaultval) {
        String s = applet.getParameter(par);
        if(s == null)
            return defaultval;
        else
            return(Integer.parseInt(s));
    }

    public static String toString(Applet applet, String par, String defaultval) {
        String s = applet.getParameter(par);
        if(s == null)
            return defaultval;
        else
            return(s);
    }
    
    public static boolean toBoolean(
                            Applet applet,
                            String par,
                            boolean defaultval) {
        String s = applet.getParameter(par);
        if(s == null)
            return defaultval;
        else
            return(s.equalsIgnoreCase("true"));
    }

    public static Color toColor(
                            Applet applet,
                            String par,
                            Color defaultval) {
        Color color;

        String s = applet.getParameter(par);
        if(s == null)
            return defaultval;
        else {
            try {
                if(s.charAt(0) == '#') {
                    char chars[];
                    // Get rid of leading #
                    chars =  new char [s.length()];
                    s.getChars(0, s.length(), chars, 0);
                    color = new Color(Integer.parseInt(
                            new String(chars, 1, s.length()-1),16));
                    return(new Color(Integer.parseInt(
                            new String(chars, 1, s.length()-1), 16)));
                } else {
                    color = new Color(Integer.parseInt(s, 16));
                    return(color);
                }
            } catch (NumberFormatException e) {
                String retcolor;
                retcolor = ColrLook.getColor(s);
                if(retcolor != null)
                    return(new Color(Integer.parseInt(retcolor, 16)));
                else
                    System.out.println("Bad color specification: " + e.getMessage());
                
                return null;
            }
        }
    }

    public static URL toURL(
                            Applet applet,
                            String par) {
        URL url = null;
        String s = applet.getParameter(par);
        if(s == null)
            return null;
        else {
            try {
                url = new URL(s);
            } catch(MalformedURLException e) {
                url = null;
            }
            if(url == null) {
                // The URL may be specified as relative to
                // the HTML document base in which the URL resides
                // We should be able to handle that
                try {
                    url = new URL(applet.getDocumentBase(), s);
                } catch(MalformedURLException e) {
                    url = null;
                }
            }
            if(url == null) {
                // The URL may be specified as relative to
                // the Code base (though that seems rather
                // unlikely) 
                //
                try {
                    url = new URL(applet.getCodeBase(), s);
                } catch(MalformedURLException e) {
                    url = null;
                }
            }
            if(url == null)
                System.out.println("Unable to load URL: " + s);
        }
        return url;
    }
    
    public static Font toFont(
                            Applet applet,
                            String par1,
                            String par2,
                            String par3) {

        String fontname;
        String fontstyle;
        int style = -1;
        int psize;
        Font font;
        Font currentfont;
        String psize_str;

        currentfont = applet.getFont();
        fontname = applet.getParameter(par1);
        if(fontname == null)
            fontname = currentfont.getName();
        fontstyle = applet.getParameter(par2);
        if(fontstyle == null)
            style = currentfont.getStyle();

        // Get the Font
        if(fontname.equalsIgnoreCase("TimesRoman")  ||
           fontname.equalsIgnoreCase("Helvetica")   ||
           fontname.equalsIgnoreCase("Courier")     ||
           fontname.equalsIgnoreCase("Dialog")      ||
           fontname.equalsIgnoreCase("DialogInput") ||
           fontname.equalsIgnoreCase("ZapfDingbats")) {
                // Do Nothing, we got a valid font
        } else {
            fontname = currentfont.getName();
        }

        if(style == -1) {
            // Get the Font Style
            if(fontstyle.equalsIgnoreCase("bold"))
                style = Font.BOLD;
            else if(fontstyle.equalsIgnoreCase("italic"))
                style = Font.ITALIC;
            else if(fontstyle.equalsIgnoreCase("bolditalic"))
                style = Font.ITALIC|Font.BOLD;
            else
                style = Font.PLAIN;
        }
        psize_str = applet.getParameter(par3);
        if(psize_str == null)
            psize = currentfont.getSize();
        else {
            try {
                psize = Integer.parseInt(psize_str);
            } catch (NumberFormatException e) {
                psize = currentfont.getSize();
                System.out.println("NumberformatException: " + psize_str);
            }
        }


        // Set up the font stuff
        font = new Font(fontname, style, psize);
        return font;
    }
}
