import java.awt.*;
import java.applet.*;

public abstract class ImgFilt {
    protected int new_width;
    protected int new_height;
    protected int newpixels[];
    protected Color trans_color;
    protected int trans_color_value;
    protected boolean transparent = false;
    protected Color bg = Color.white;
    protected Color fg = Color.black;
    protected Font font;
    protected String tx;
    protected Applet applet;
    protected boolean underline;

    public ImgFilt() {
        new_width  = -1;
        new_height = -1;
    }

    public abstract int[] filter(int[] p1, int w, int h);

    public int getWidth() {
        return new_width;
    }

    public int getHeight() {
        return new_height;
    }

    public void setparameter(String s, int i) {
        // Do nothing
    }

    public void setparameter(String s) {
        // Do nothing
    }

    public void setTransparentColor(Color color) {
        transparent = true;
        trans_color = color;
        trans_color_value = (0xFF << 24) | 
                            (color.getRed()   << 16) |
                            (color.getGreen() <<  8) |
                            (color.getBlue());
    }

    public void setTransparentColor(boolean t, Color color) {
        transparent = t;
        trans_color = color;
        trans_color_value = (0xFF << 24) | 
                            (color.getRed()   << 16) |
                            (color.getGreen() <<  8) |
                            (color.getBlue());
    }

    public void setTransparent(boolean t) {
        transparent = t;
    }

    public void setBackground(Color bg) {
        this.bg = bg;
    }

    public void setForeground(Color fg) {
        this.fg = fg;
    }

    public void setFont(Font font) {
        this.font = font;
    }

    public void setApplet(Applet a) {
        applet = a;
    }

    public void setText(String t) {
        tx = t;
    }

    public void setUnderline(boolean b) {
        underline = b;
    }

    public Color String2Color(String s) {
        String retcolor;

	if(s == null)
	    return null;
        try {
            if(s.charAt(0) == '#') {
                char chars[];
                // Get rid of leading #
                chars =  new char [s.length()];
                s.getChars(0, s.length(), chars, 0);
                return(new Color(Integer.parseInt(
                        new String(chars, 1, s.length()-1), 16)));
            } else {
                return(new Color(Integer.parseInt(s, 16)));
            }
        } catch (NumberFormatException e) {
            retcolor = ColrLook.getColor(s);
            if(retcolor != null)
                return(new Color(Integer.parseInt(retcolor, 16)));
            else
                System.out.println("Bad color specification: " + e.getMessage());
            
            return null;
        }
    }

    //
    // The drawUnderline method draws an underline
    // The underline is actually a filled rectangle
    // whose size is based on the width of a pipe
    // character from the same font.  It works!
    //
    protected void drawUnderline(Graphics g,
                           FontMetrics fm,
                           int x,
                           int y,
                           int w,
                           Color c) {
        if(underline) {
            int pipewidth = fm.charWidth('|');
            g.setColor(c);
            g.fillRect(x, y, w, Math.max(1, pipewidth/4));
        }
    }
}
