public class fblur extends ImgFilt {
    int blur = 1;
    int pixels_col[][];
    int samplecount;

    public void setparameter(String str_blur, int i) {
        blur = Integer.parseInt(str_blur);
    }

    public int[] filter(int[] p1, int w, int h) {
        int x, y, xb, yb;
        int index, new_index;
        long sum;
        int imagesize = w*h;
        int alpha, red, green, blue;

        if(p1.length != (imagesize)) {
            System.out.println("blur filter: got array of wrong size");
            return null;
        }
        newpixels = new int[imagesize];
        pixels_col = new int[imagesize][4];
        for(y=0;y<h;y++) {
            for(x=0;x<w;x++) {
                index =  (y*w) + x;
                //pixels_col[index][0] += getAlpha(p1[index]);
                pixels_col[index][1] += getRed  (p1[index]);
                pixels_col[index][2] += getGreen(p1[index]);
                pixels_col[index][3] += getBlue (p1[index]);
            }
        }

        for(y=0;y<h;y++) {
            for(x=0;x<w;x++) {
                alpha = red = green = blue = 0;
                sum=0;
                index =  (y*w) + x;
                samplecount = 0;

                for(yb=-1;yb<=1;yb++) {
                    for(xb=-1;xb<=1;xb++) {
                        new_index = index + ((w*yb)+xb);
                        if(new_index < 0 || new_index >= imagesize)
                            continue;
                        if(x + xb >= w)
                            continue;
                        if(yb == 0 && xb == 0) {
                            red   += pixels_col[new_index][1];
                            green += pixels_col[new_index][2];
                            blue  += pixels_col[new_index][3];
                            samplecount++;
                        } else {
                            red   += (blur*pixels_col[new_index][1]);
                            green += (blur*pixels_col[new_index][2]);
                            blue  += (blur*pixels_col[new_index][3]);
                            samplecount += blur;
                        }
                    }
                }
                if(red < 0)
                    red = 0;
                if(green < 0)
                    green = 0;
                if(blue < 0)
                    blue = 0;
                newpixels[index] =
                        ((p1[index] & 0xff000000) |
                        //(((alpha/samplecount) << 24) |
                         ((red  /samplecount) << 16) |
                         ((green/samplecount) <<  8) |
                         ((blue /samplecount)));
            }
        }
        new_width  = w;
        new_height = h;
        return newpixels;
    }

    public int getAlpha(int a) {
        return ((a&0xff000000) >>> 24);
    }

    public int getRed(int a) {
        return ((a&0x00ff0000) >> 16);
    }

    public int getGreen(int a) {
        return ((a&0x0000ff00) >> 8);
    }

    public int getBlue(int a) {
        return (a&0x000000ff);
    }
}
