import java.awt.*;
import java.awt.image.*;

public class fdepthfade extends ImgFilt {
    int depth_xoffset = -10;
    int depth_yoffset = -10;
    Color depth_color = null;
    Color outline_color = null;

    public void setparameter(String str, int i) {
        switch(i) {
        case 0:
            depth_xoffset = Integer.parseInt(str);
            break;
        case 1:
            depth_yoffset = Integer.parseInt(str);
            break;
        case 2:
            if(str != null)
                depth_color = String2Color(str);
            break;
        case 3:
            if(str != null)
                outline_color = String2Color(str);
            break;
        }
    }

    public int[] filter(int[] p1, int w, int h) {
        int i;
        int x, y;
        int divisor;
        double xoff, yoff, ddivisor;
        int ascent, descent;
        FontMetrics fontmetrics;
        Image image;
        Graphics g;
        int pixels[];
        boolean retval;
        ftransp tp;
        int fg_red, fg_green, fg_blue;
        int depth_red, depth_green, depth_blue;
        Color   FadeColor[];    // The array of fading colors
	ImgGetr ig;

        if(depth_color == null)
            depth_color = bg;
        divisor = Math.max(Math.abs(depth_xoffset), Math.abs(depth_yoffset));
        ddivisor = (double)divisor;
        
        fg_red   = fg.getRed();
        fg_green = fg.getGreen();
        fg_blue  = fg.getBlue();

        depth_red   = depth_color.getRed();
        depth_green = depth_color.getGreen();
        depth_blue  = depth_color.getBlue();

        fontmetrics = applet.getFontMetrics(font);
        ascent = fontmetrics.getAscent();
        descent = fontmetrics.getDescent();
        new_width = fontmetrics.stringWidth(tx) + Math.abs(divisor);
        new_height = fontmetrics.getHeight() + Math.abs(divisor);

        // Recreate the image because we need the bigger size
        image = applet.createImage(new_width, new_height); 
        g = image.getGraphics();
        g.setFont(font);
        g.setColor(bg);
        g.fillRect(0, 0, new_width, new_height);

        FadeColor = new Color[divisor];
        for(i=0;i<divisor;i++) {
            FadeColor[i] = new Color(
                AdjColor.CalcFade(fg_red,   depth_red,   i, divisor),
                AdjColor.CalcFade(fg_green, depth_green, i, divisor),
                AdjColor.CalcFade(fg_blue,  depth_blue,  i, divisor));
        }

        // If the depth is negative then we must offset the position
        // of the non-depth text to allow room for the depth
        x = (depth_xoffset < 0) ? Math.abs(depth_xoffset) : 0;
        y = (depth_yoffset < 0) ? Math.abs(depth_yoffset) : 0;


        for(i=divisor-1;i>0;i--) {
            if(outline_color != null && i == 1)
                g.setColor(outline_color);
            else
                g.setColor(FadeColor[i]);
            g.drawString(tx,
                    x+i*depth_xoffset/divisor,
                    y+ascent+(i*depth_yoffset/divisor));
            drawUnderline(g, fontmetrics,
                    x+i*depth_xoffset/divisor,
                    y+ascent+(i*depth_yoffset/divisor),
                    new_width, FadeColor[i]);
        }
        g.setColor(fg);
        g.drawString(tx, x, y+ascent);
        drawUnderline(g, fontmetrics, x, y+ascent,
                        new_width, fg);

	ig = new ImgGetr(applet);
        pixels = ig.getPixels(image, applet);
        if(transparent) {
            tp = new ftransp();
            tp.setTransparentColor(bg);
            pixels = tp.filter(pixels, new_width, new_height);
        }
        return pixels;
    }
}
