import java.awt.*;
import java.awt.image.*;

public class femboss extends ImgFilt {
    int depth = 1;
    double intensity = .50;

    public void setparameter(String str, int i) {
        switch(i) {
        case 0:
            depth = Integer.parseInt(str);
            break;
        case 1:
            intensity = (double)(Integer.parseInt(str)/100.0);
            break;
        }
    }

    public int[] filter(int[] p1, int w, int h) {
        int i;
        int x, y;
        int divisor;
        double xoff, yoff, ddivisor;
        int ascent, descent;
        FontMetrics fontmetrics;
        Image image;
        Graphics g;
        int pixels[];
        boolean retval;
        ftransp tp;
        Color   dark;
        Color   bright;
        ImgGetr ig;

        fontmetrics = applet.getFontMetrics(font);
        ascent = fontmetrics.getAscent();
        descent = fontmetrics.getDescent();
        new_width = fontmetrics.stringWidth(tx);
        new_height = fontmetrics.getHeight();

        // Clear out whatever might already be there
        image = applet.createImage(new_width, new_height); 
        g = image.getGraphics();
        g.setFont(font);
        g.setColor(bg);
        g.fillRect(0, 0, new_width, new_height);

        // To Create the embossed look, draw the string in a darker
        // and brighter shade than the background, offset by depth
        dark = AdjColor.darkenit(bg, intensity);
        bright = AdjColor.brightenit(bg, intensity);

        // Upper Left edge
        g.setColor(bright);
        g.drawString(tx, 0, ascent-depth);
        drawUnderline(g, fontmetrics, 0,
                            ascent-depth+Math.max(1, (descent/4))+depth,
                            new_width, dark);

        // Lower Right edge
        g.setColor(dark);
        g.drawString(tx, depth*2, ascent+depth);
        drawUnderline(g, fontmetrics, depth*2,
                            ascent+depth+Math.max(1, (descent/4))-depth,
                            new_width, bright);

        // The main body of the characters
        g.setColor(bg);
        g.drawString(tx, depth, ascent);
        drawUnderline(g, fontmetrics, depth,
                            ascent+Math.max(1, (descent/4)),
                            new_width, bg);

        // Now grab the pixels for use with filters
        ig = new ImgGetr(applet);
        pixels = ig.getPixels(image, applet);
        if(transparent) {
            tp = new ftransp();
            tp.setTransparentColor(bg);
            pixels = tp.filter(pixels, new_width, new_height);
        }
        return pixels;
    }
}
