import java.awt.Color;
import java.util.*;

public class ffade extends ImgFilt {
    int percent = 50;
    Color fade_to_color = null;

    public void setparameter(String str, int i) {
        switch(i) {
        case 0:
            percent = Integer.parseInt(str);
            break;
        case 1:
            fade_to_color = String2Color(str);
            break;
        }
    }

    public int[] filter(int[] p1, int w, int h) {
        int x, y, i;
        int index, new_index;
        int fade_red, fade_green, fade_blue;
        int alpha, red, green, blue;
        int nred, ngreen, nblue;
        Hashtable colors = new Hashtable();
        Integer newval;
        Integer I;

        if(p1.length != (w*h)) {
            System.out.println("fadeto filter: got array of wrong size");
            return null;
        }
        if(fade_to_color == null)
            fade_to_color = bg;

        fade_red   = fade_to_color.getRed();
        fade_green = fade_to_color.getGreen();
        fade_blue  = fade_to_color.getBlue();

        newpixels = new int[h * w];

        // We'll try to speed things up a little by using a HashTable
        // in which to store values.  If we find that same color
        // then we don't have to do the math again.
        // It's not clear that this is faster in all cases.
        //
        new_index = 0;
        for(y=0;y<h;y++) {
            for(x=0;x<w;x++) {
                index = (y*w) + x;
                I = new Integer(p1[index]);
                newval = (Integer)colors.get(I);
                if(newval == null) {
                    alpha = (p1[index] & 0xff000000) >>> 24;
                    red   = (p1[index] & 0x00ff0000) >> 16;
                    green = (p1[index] & 0x0000ff00) >> 8;
                    blue  = (p1[index] & 0x000000ff);

                    // ===== RED =====
                    if(red > fade_red)
                        nred = red - (((red - fade_red)*percent)/100);
                    else
                        nred = red + (((fade_red - red)*percent)/100);

                    // ===== GREEN =====
                    if(green > fade_green)
                        ngreen = green - (((green - fade_green)*percent)/100);
                    else
                        ngreen = green + (((fade_green - green)*percent)/100);

                    // ===== BLUE =====
                    if(blue > fade_blue)
                        nblue = blue - (((blue - fade_blue)*percent)/100);
                    else
                        nblue = blue + (((fade_blue - blue)*percent)/100);

                    newpixels[new_index] =
                        ((alpha<<24) | (nred<<16) | (ngreen<<8) | nblue);
                    colors.put(I, new Integer(newpixels[new_index]));
                } else {
                    newpixels[new_index] = newval.intValue();
                }
                new_index++;
            }
        }
        new_width  = w;
        new_height = h;
        return newpixels;
    }
}
