import java.awt.Color;

public class frevbits extends ImgFilt {
    Color c1 = bg;
    Color c2 = fg;

    // If swap is not called then the c1, and c2 colors will default
    // to the background and foreground colors (assuming that
    // setBackground() and setForeground() were called
    public void swap(Color c1, Color c2) {
        this.c1 = c1;
        this.c2 = c2;
    }

    public int[] filter(int[] p1, int w, int h) {
        int x, y, i;
        int index, new_index;
        int c1_value;
        int c2_value;

        if(p1.length != (w*h)) {
            System.out.println("revbits filter: got array of wrong size");
            return null;
        }

        c1_value =  (0xFF << 24) | 
                    (c1.getRed()   << 16) |
                    (c1.getGreen() <<  8) |
                    (c1.getBlue());
        c2_value =  (0xFF << 24) | 
                    (c2.getRed()   << 16) |
                    (c2.getGreen() <<  8) |
                    (c2.getBlue());

        newpixels = new int[h * w];

        new_index = 0;
        for(y=0;y<h;y++) {
            for(x=0;x<w;x++) {
                index = (y*w) + x;
                if(p1[index] == c1_value)
                    newpixels[new_index++] = c2_value;
                else if(p1[index] == c2_value)
                    newpixels[new_index++] = c1_value;
                else
                    newpixels[new_index++] = p1[index];
            }
        }
        new_width  = w;
        new_height = h;
        return newpixels;
    }
}
