import java.awt.Color;

public class frotate extends ImgFilt {
    int degree = 0;
    double radians;

    public void setparameter(String str, int i) {
        switch(i) {
        case 0:
            try {
		degree = Integer.parseInt(str);
            } catch (NumberFormatException e) {
                System.err.println("rotate: Invalid degree " + str);
                degree = 0;
            }
            break;
        }
    }

    public int[] filter(int[] p1, int w, int h) {
        int x, y;
        int srcindex, destindex;
        int newy;
        int newx;
        double sine, cosine;
        int imagesize = w*h;
        int bigimagesize;
        int vert_shift, horiz_shift;
        int new_index;
	int biggestx, biggesty, smallesty;
	int old_index, oldx, oldy;

        if(p1.length != (imagesize)) {
            System.out.println("rotate filter: got array of wrong size");
            return null;
        }
	if(degree > 360)
	    degree %= 360;
	if (degree < 0) {
	    if(degree < -360)
		degree %= 360;
	    degree = 360 + degree;
	}
	if(degree >= 270) {
	    frot270 r270 = new frot270();
	    p1 = r270.filter(p1, w, h);
	    w = r270.getWidth();
	    h = r270.getHeight();
	    if(degree == 270) {
		new_width = w;
		new_height = h;
		return p1;
	    }
	    degree -= 270;
	} else if(degree > 180) {
	    frot180 r180 = new frot180();
	    p1 = r180.filter(p1, w, h);
	    w = r180.getWidth();
	    h = r180.getHeight();
	    if(degree == 180) {
		new_width = w;
		new_height = h;
		return p1;
	    }
	    degree -= 180;
	} else if(degree > 90) {
	    frot90 r90 = new frot90();
	    p1 = r90.filter(p1, w, h);
	    w = r90.getWidth();
	    h = r90.getHeight();
	    if(degree == 90) {
		new_width = w;
		new_height = h;
		return p1;
	    }
	    degree -= 90;
	}
	degree = -degree;

        radians = Math.PI * (double)degree / 180.0;
        sine = Math.sin(radians);
        cosine = Math.cos(radians);

	newx = ((int)Math.round(((w) * cosine) - 
			((h) * sine)));
	newy = ((int)Math.round(((w) * sine) + 
			((h) * cosine)));
	biggestx = newx;
	biggesty = newy;
	smallesty = newy;

	newx = ((int)Math.round(((0) * cosine) - 
			((h) * sine)));
	newy = ((int)Math.round(((0) * sine) + 
			((h) * cosine)));
	if(newx > biggestx)
	    biggestx = newx;
	if(newy > biggesty)
	    biggesty = newy;
	if(newy < smallesty)
	    smallesty = newy;

	newx = ((int)Math.round(((w) * cosine) - 
			((0) * sine)));
	newy = ((int)Math.round(((w) * sine) + 
			((0) * cosine)));

	if(newx > biggestx)
	    biggestx = newx;
	if(newy > biggesty)
	    biggesty = newy;
	if(newy < smallesty)
	    smallesty = newy;

	degree = -degree;

        radians = Math.PI * (double)degree / 180.0;
        sine = Math.sin(radians);
        cosine = Math.cos(radians);



        vert_shift = (int)Math.abs(Math.round(Math.tan(radians) * w));
        horiz_shift = (int)Math.abs(Math.round(Math.sin(radians) * h));

	new_width = biggestx;
	new_height = biggesty - smallesty;
	horiz_shift = biggestx - w;
	vert_shift = biggesty;
        bigimagesize = new_width * new_height;
        newpixels = new int[(new_width) * (new_height)];
        for(y=0;y<new_height;y++) {
            for(x=0;x<new_width;x++) {
                oldx = (int)Math.round((x * cosine) - 
				((y+smallesty) * sine));
                oldy = (int)Math.round((x * sine) + 
				((y+smallesty) * cosine));
                old_index = idx(oldx, oldy, w);
                if(oldx > 0 && oldx < w &&
		   oldy > 0 && oldy < h &&
                   old_index > 0 && old_index < imagesize)
                    newpixels[idx(x, y, new_width)] = p1[old_index];
            }
        }
        return newpixels;
    }

    public int idx(int x, int y, int w) {
        return (y*w)+x;
    }
}
