import java.awt.*;
import java.awt.image.*;

public class fshadow extends ImgFilt {
    int shadow_xoffset = 2;
    int shadow_yoffset = 2;
    Color shadow_color = new Color(100, 100, 100);

    public void setparameter(String str, int i) {
        switch(i) {
        case 0:
            shadow_xoffset = Integer.parseInt(str);
            break;
        case 1:
            shadow_yoffset = Integer.parseInt(str);
            break;
        case 2:
            shadow_color = String2Color(str);
            break;
        }
    }

    public int[] filter(int[] p1, int w, int h) {
        int x, y;
        Image image;
        Graphics g;
        int ascent, descent;
        FontMetrics fontmetrics;
        int pixels[];
        boolean retval;
        ftransp tp;
	ImgGetr ig;

        // Ignore p1, w, and h

        fontmetrics = applet.getFontMetrics(font);
        ascent = fontmetrics.getAscent();
        descent = fontmetrics.getDescent();
        new_width = fontmetrics.stringWidth(tx) + Math.abs(shadow_xoffset);
        new_height = fontmetrics.getHeight() + Math.abs(shadow_yoffset);

        image = applet.createImage(new_width, new_height);
        g = image.getGraphics();
        g.setFont(font);
        g.setColor(bg);
        g.fillRect(0, 0, new_width, new_height);

        x = (shadow_xoffset < 0) ? Math.abs(shadow_xoffset) : 0;
        y = (shadow_yoffset < 0) ? Math.abs(shadow_yoffset) : 0;

        // Draw text in shadow color offset by xoffset, yoffset
        g.setColor(shadow_color);
        g.drawString(tx, x+shadow_xoffset,
                        y+ascent+shadow_yoffset);
        drawUnderline(g, fontmetrics, x+shadow_xoffset,
                       y+ascent+shadow_yoffset+
                       Math.max(1, (descent/4)),
                       new_width, shadow_color);

        // Now draw the main foreground text
        g.setColor(fg);
        g.drawString(tx, x, y+ascent);
        drawUnderline(g, fontmetrics, x,
                        y+ascent+Math.max(1, (descent/4)),
                        new_width, fg);

        // Grab the pixels
	ig = new ImgGetr(applet);
        pixels = ig.getPixels(image, applet);
        if(transparent) {
            tp = new ftransp();
            tp.setTransparentColor(bg);
            pixels = tp.filter(pixels, new_width, new_height);
        }
        return pixels;
    }
}
