import java.awt.*;
import java.awt.image.*;

public class fsoftshadow extends ImgFilt {
    int shadow_xoffset = 2;
    int shadow_yoffset = 2;
    Color shadow_color = new Color(150, 150, 150);
    int soft_thickness = 2;
    Color light_shadow[];

    public void setparameter(String str, int i) {
        switch(i) {
        case 0:
            shadow_xoffset = Integer.parseInt(str);
            break;
        case 1:
            shadow_yoffset = Integer.parseInt(str);
            break;
        case 2:
            shadow_color = String2Color(str);
            break;
        case 3:
            soft_thickness = Integer.parseInt(str);
            break;
        }
    }

    public int[] filter(int[] p1, int w, int h) {
        int i;
        int x, y;
        Image image;
        Graphics g;
        int ascent, descent;
        FontMetrics fontmetrics;
        int pixels[];
        boolean retval;
        ftransp tp;
        ImgGetr ig;

        // Ignore p1, w, and h

        fontmetrics = applet.getFontMetrics(font);
        ascent = fontmetrics.getAscent();
        descent = fontmetrics.getDescent();
        new_width = fontmetrics.stringWidth(tx) + Math.abs(shadow_xoffset);
        new_height = fontmetrics.getHeight() + Math.abs(shadow_yoffset);

        image = applet.createImage(new_width, new_height);
        g = image.getGraphics();
        g.setFont(font);
        g.setColor(bg);
        g.fillRect(0, 0, new_width, new_height);

        x = (shadow_xoffset < 0) ? 0 : Math.abs(shadow_xoffset);
        y = (shadow_yoffset < 0) ? 0 : Math.abs(shadow_yoffset);

        // Draw text in lighter shadow color offset by xoffset+1, yoffset+1
        light_shadow = new Color[soft_thickness];
        for(i=0;i<soft_thickness;i++)
            light_shadow[i] = AdjColor.Fade(shadow_color,
                                bg, 0.8*(i+1)/soft_thickness);



        // Draw text in shadow color offset by xoffset, yoffset
        // The size of soft_thickness determines how much work
        // we put into creating the "soft shadow". Too big a number
        // creates a silly looking shadow
        for(i=0;i<soft_thickness;i++) {
            int soft_offset = soft_thickness-i;
            g.setColor(light_shadow[i]);
            for(int j=-soft_offset;j<soft_offset;j++)
                for(int k=-soft_offset;k<soft_offset;k++) {
                    g.drawString(tx, x+j, y+ascent+k);
                    drawUnderline(g, fontmetrics, x+j,
                        y+ascent+k+Math.max(1, (descent/4)),
                        new_width, light_shadow[i]);
                }
        }

        // If the shadow is negative then we must offset the position
        // of the non-shadow text to allow room for the shadow
        x = (shadow_xoffset < 0) ? Math.abs(shadow_xoffset) : 0;
        y = (shadow_yoffset < 0) ? Math.abs(shadow_yoffset) : 0;

        // Now draw the main foreground text
        g.setColor(fg);
        g.drawString(tx, x, y+ascent);
        drawUnderline(g, fontmetrics, x,
                        y+ascent+Math.max(1, (descent/4)),
                        new_width, fg);

        // Grab the pixels
        ig = new ImgGetr(applet);
        pixels = ig.getPixels(image, applet);
        if(transparent) {
            tp = new ftransp();
            tp.setTransparentColor(bg);
            pixels = tp.filter(pixels, new_width, new_height);
        }
        return pixels;
    }
}
