public class fwaveimage extends ImgFilt {
    int amplitude = 10;
    int frequency = 10;
    int xtrans = 0;
    int ytrans = 0;
    int beginrange = -1;
    int endrange = -1;
    int sinearray[];

    public void setparameter(String param, int i) {
        switch(i) {
        case 0:
            amplitude = Integer.parseInt(param);
            break;
        case 1:
            frequency = Integer.parseInt(param);
            break;
        case 2:
            xtrans = Integer.parseInt(param);
            break;
        case 3:
            ytrans = Integer.parseInt(param);
            break;
        case 4:
            beginrange = Integer.parseInt(param);
            break;
        case 5:
            endrange = Integer.parseInt(param);
            break;
        }
    }

    public int[] filter(int[] p1, int w, int h) {
        int x, y;
        int index, new_index;
        int newy;
        int newh;
        int i;
        int bg_value;
        int abs_amplitude = Math.abs(amplitude);
        int new_size;
        ftransp tp;

        if(p1.length != (w*h)) {
            System.out.println("waveimage filter: got array of wrong size");
            return null;
        }

        if(beginrange == -1)
            beginrange = 0;
        if(endrange == -1)
            endrange = w;

        newh = h+(abs_amplitude*2);
        new_size = w*newh;
        newpixels = new int[new_size];
	sinearray = new int[w];

        // Initialize the newpixels so we don't end up with
        // transparent background for pixels that are not
        // directly written to
        bg_value = 0xff000000 | 
                   (bg.getRed() << 16) |
                   (bg.getGreen() << 8) |
                    bg.getBlue();
        for(i=0;i<new_size;i++)
            newpixels[i] = bg_value;
        new_index = 0;

	// To save time, precalculate the sine function stuff once
	for(x=0;x<w;x++)
	   sinearray[x] = ((int)(amplitude*Math.sin(((double)(x-xtrans)) /
		    ((double)frequency))));

        for(y=0;y<h;y++) {
            for(x=0;x<w;x++) {
                index =  (y*w) + x;
		if(x < beginrange || x > endrange) {
		    newy = y + abs_amplitude;
		} else {
		    newy = y + abs_amplitude + sinearray[x] + ytrans;
                       //((int)(amplitude*Math.sin(((double)(x-xtrans)) /
                            //((double)frequency)))) + ytrans;
		}
                new_index = (newy*w) + x;
                if(new_index > 0 && new_index < new_size)
                    newpixels[new_index] = p1[index];
            }
        }
        new_width  = w;
        new_height = newh;
        if(transparent) {
            tp = new ftransp();
            tp.setTransparentColor(bg);
            newpixels = tp.filter(newpixels, new_width, new_height);
        }
        return newpixels;
    }
}
