import java.awt.*;
import java.awt.image.*;

public class fwavetext extends ImgFilt {
    int amplitude = 10;
    int wavelength = 10;
    int xtrans = 0;
    int ytrans = 0;
    int beginrange = -1;
    int endrange = -1;

    public void setparameter(String str, int i) {
        switch(i) {
        case 0:
            amplitude = Integer.parseInt(str);
            break;
        case 1:
            wavelength = Integer.parseInt(str);
            break;
        case 2:
            xtrans = Integer.parseInt(str);
            break;
        case 3:
            ytrans = Integer.parseInt(str);
            break;
        case 4:
            beginrange = Integer.parseInt(str);
            break;
        case 5:
            endrange = Integer.parseInt(str);
            break;
        }
    }

    public int[] filter(int[] p1, int w, int h) {
        int     x = -1, y = -1;
        Image    image;
        Graphics g;
        int      ascent;
        int      descent;
        char     separated[];
        int      total_width;
        int      xlocation[];
        int      xwidth[];
        int      lastx = 0, lasty = 0;
        int      i;
        int      midpoint;
        int      charwidth;
        int      str_len;
        FontMetrics fontmetrics;
        int pixels[];
        boolean retval;
        ftransp tp;
	ImgGetr ig;

        str_len = tx.length();
        separated =  new char [str_len];
        xlocation =  new int  [str_len];
        xwidth    =  new int  [str_len];
        tx.getChars(0, str_len, separated, 0);
        fontmetrics = applet.getFontMetrics(font);
        ascent = fontmetrics.getAscent();
        descent = fontmetrics.getDescent();

        if(beginrange == -1)
            beginrange = 0;
        if(endrange == -1)
            endrange = str_len;

        // Calculate the x locations for each character based on width
        total_width = 0;
        for(i=0;i<str_len;i++) {
            xwidth[i] = fontmetrics.charWidth(separated[i]);
            total_width += xwidth[i];
            if(i+1<str_len)
                xlocation[i+1] = total_width;
        }

        new_width = fontmetrics.stringWidth(tx);
        new_height = (amplitude*2) + fontmetrics.getHeight();

        // Recreate the image because we need the bigger size
        image = applet.createImage(new_width, new_height); 
        g = image.getGraphics();
        g.setFont(font);
        g.setColor(bg);
        g.fillRect(0, 0, new_width, new_height);

        // Underline
        if(underline) {
            g.setColor(fg);
            for(i=0;i<xlocation[str_len-1]+xwidth[str_len-1];i++) {
                lastx = x;
                lasty = y;
                x = i;
                // Since y is calculated to be the upper part of the
                // allocated space, add half the height to get to the center
                y = (new_height/2) + descent +
                       ((int)(amplitude*
                        Math.sin((double)(x-xtrans)/(wavelength)))) + ytrans;
                if(lastx != -1 && lasty != -1)
                    g.drawLine(x, y, lastx, lasty);
            }
        }

        lastx = 0;
        lasty = 0;
        x = 0;
        y = 0;
        for(i=0;i<str_len;i++) {
            g.setColor(fg);
            lastx = x;
            lasty = y;
            charwidth = fontmetrics.charWidth(separated[i]);
            x = xlocation[i];
            midpoint = x + (charwidth/2);
            if(i < beginrange || i > endrange) {
                y = (new_height/2) + descent;
            } else {
                y = (new_height/2) + descent + 
                    ((int)(amplitude*
                    Math.sin((double)(midpoint-xtrans)/
                                (wavelength)))) + ytrans;
            }
            g.drawChars(separated, i,1,x, y);
        }

	ig = new ImgGetr(applet);
        pixels = ig.getPixels(image, applet);
        if(transparent) {
            tp = new ftransp();
            tp.setTransparentColor(bg);
            pixels = tp.filter(pixels, new_width, new_height);
        }
        return pixels;
    }
}
