import java.awt.*;
import java.applet.*;
import java.net.*;
import java.io.*;

//
// URLAudImgTxtBG does everything thing that URLAudImgTxt does
// but in addition is draw a background image which
// can also be tiled
//
public class URLAudImgTxtBG extends URLAudImgTxt {
    protected boolean tile;             // Tiled?
    protected Image   bgimage;          // The background image
    protected String  bgimage_file;     // Name of the background image
    protected ImgGetr ig;               // The Image Getter class
    protected int      bgimage_width;
    protected int      bgimage_height;
    protected int      bgimageXoffset;
    protected int      bgimageYoffset;
    protected Image    tiled_bgimage;
    protected int      app_width;
    protected int      app_height;
    protected Graphics bg_g;

    public void init() {
        super.init();
        tile           = GetParm.toBoolean(this, "AppTile",     false);
        bgimage_file   = GetParm.toString(this,  "AppBGImage",  null);
        bgimageXoffset = GetParm.toInt(this,     "AppBGImageXOffset",  0);
        bgimageYoffset = GetParm.toInt(this,     "AppBGImageYOffset",  0);

        if(bgimage_file != null) {
            ig = new ImgGetr(this);
            bgimage = ig.process(getDocumentBase(), bgimage_file, false);
            ig.prepareImage(bgimage, this);
            bgimage_width = ig.getWidth(bgimage, this);
            bgimage_height = ig.getHeight(bgimage, this);
        }
    }    

    public void paint(Graphics g) {
        tilebackground(g);
        super.paint(g);
    }

    protected void tilebackground(Graphics g) {
        int i, j;

        if(bgimage == null)
            return;
        if(ig.isImagePrepared(bgimage, this) == false)
            ig.loadImageAndWait(bgimage, this);
        //
        // If the applet has changed size or this is the first time
        // tilebackground has been called then create the bg image
        //
        if(app_width != size().width || app_height != size().height) {
            app_width  = size().width;
            app_height = size().height;

            tiled_bgimage = createImage(size().width, size().height); 
            bg_g = tiled_bgimage.getGraphics();
            if(tile & (bgimageXoffset != 0 || bgimageYoffset != 0)) {
                for(i=-bgimage_height;i<app_height;i+=bgimage_height) {
                    for(j=-bgimage_width;j<app_width;j+=bgimage_width) {
                        bg_g.drawImage(bgimage, j+bgimageYoffset,
                                        i+bgimageXoffset, this);
                    }
                }

            } else if(tile) {
                for(i=-bgimage_height;i<app_height;i+=bgimage_height) {
                    for(j=-bgimage_width;j<app_width;j+=bgimage_width) {
                        bg_g.drawImage(bgimage, j+2, i+2, this);
                    }
                }
            } else {
                bg_g.drawImage(bgimage, bgimageXoffset,
                                        bgimageYoffset, this);
            }
        }

        if(tiled_bgimage != null) {
            g.drawImage(tiled_bgimage, 0, 0, this);
        }
    }

    public synchronized boolean imageUpdate(Image img,
					    int infoflags, 
					    int x, int y,
					    int width,
					    int height){
	if((infoflags & ERROR) != 0) {
	    if(img.equals(this.img))
		System.out.println("Error getting image = " + img_file);
	    else if(img.equals(bgimage))
		System.out.println("Error getting image = " + bgimage_file);
	    img.flush();
	    img = null;
	    return false;
	}
	if((infoflags & ABORT) != 0) {
	    if(img.equals(this.img))
		System.out.println("Abort image = " + img_file);
	    else if(img.equals(bgimage))
		System.out.println("Abort image = " + bgimage_file);
	    img.flush();
	    img = null;
	    return false;
	}
	if((infoflags & ALLBITS) != 0) {
	    return true;
	}
	return super.imageUpdate(img, infoflags, x, y, width, height);
    }
}
