import java.awt.*;
import java.awt.image.*;

public class WaveText extends OffScr {
    protected String    amplitude;
    protected String    wavelength;
    protected String    xtrans;
    protected String    ytrans;
    protected String    beginrange;
    protected String    endrange;

    public void init() {
        int x, y;
        super.init();

        amplitude   = GetParm.toString(this, "Amplitude", "10");
        wavelength  = GetParm.toString(this, "WaveTextLength", "10");
        xtrans      = GetParm.toString(this, "XTranslate", "0");
        ytrans      = GetParm.toString(this, "YTranslate", "0");
        beginrange  = GetParm.toString(this, "BeginRange", "-1");
        endrange    = GetParm.toString(this, "EndRange", "-1");

        //========= WAVE THE TEXT ==============
        fwavetext wv;
        wv = new fwavetext();
        wv.setText(tx);
        wv.setApplet(this);
        wv.setFont(tx_font);
        wv.setBackground(tx_bg_color!=null ? tx_bg_color : app_bg_color);
        wv.setTransparent(tx_bg_color!=null ? false : true);
        wv.setForeground(tx_color);
        wv.setUnderline(tx_underline);
        wv.setparameter(amplitude, 0);
        wv.setparameter(wavelength, 1);
        wv.setparameter(xtrans, 2);
        wv.setparameter(ytrans, 3);
        wv.setparameter(beginrange, 4);
        wv.setparameter(endrange, 5);
        tx_pixels = wv.filter(null, 0, 0);      // These params get ignored
        tx_width = wv.getWidth();
        tx_height = wv.getHeight();

        doStandardFilters();
    }
}
